<?php
/**
 * InventaireDataBean.php : DataBean utilis pour reprsenter l'ensemble des objets du joueur
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe & Thierry Bousquet.
 *
 * Ce logiciel est distribu selon les termes de la GNU General Public License v2.
 */
class InventaireDataBean {
  
  /** id objet */
  var $id = "";
  /** nom objet */
  var $name = "";
  /** image */
  var $image = "";
  /** pds */
  var $pds = "";
  /** pdsMax */
  var $pdsMax = "";
  /** actif */
  var $actif = "";
  /** description */
  var $description = "";
  /** Comptence */  
  var $competence = "";
  /** bonus */
  var $bonus = "";
  /** fiabilite */
  var $fiabilite = "";
  /** degats */
  var $degats = "";
  /** acceleration */
  var $acceleration = "";
  /** prix neuf */
  var $prix = ""; 
  /** prix achat */
  var $prix_achat = ""; 
  /** prix vente */
  var $prix_vente = ""; 
  /** cot rparation */
  var $prix_repare = ""; 
  /** level d'utilisation */
  var $level = ""; 
  /** comptence sur 3 caractre */
  var $cmp = ""; 
  
  function InventaireDataBean() {
  }
  
  function setId($id) {
    $this->id = $id;
  }
  function getId() {
    return $this->id;
  }
  
  function setName($name) {
    $this->name = $name;
  }
  function getName() {
    return $this->name;
  }

  function setImage($image) {
    $this->image = $image;
  }
  function getImage() {
    return $this->image;
  }

  function setPds($pds) {
    $this->pds = $pds;
  }
  function getPds() {
    return $this->pds;
  }

  function setPdsMax($pdsMax) {
    $this->pdsMax = $pdsMax;
  }
  function getPdsMax() {
    return $this->pdsMax;
  }
  function hasPdsMax() {
    return ($this->pdsMax != "");
  }
  function isReparable() {
    $reparable = $this->hasPdsMax();
    return (($this->getCmp() == "TIR" || $this->getCmp() == "PHY" || $this->getCmp() == "BGR" || $this->getCmp() == "PIL")&& $this->hasPdsMax() && $this->getPds() < $this->getPdsMax() && $this->getPds() > 0);
  }
  
  function setActif($actif) {
    $this->actif = $actif;
  }
  function isActif() {
    return $this->actif;
  }
  function isActivable() {
    return ($this->getPds() > 0);
  }

  function setDescription($description) {
    $this->description = $description;
  }
  function getDescription() {
    return $this->description;
  }
  
  function setCompetence($competence) {
    $this->competence = $competence;
  }
  function getCompetence() {
    return $this->competence;
  }

  function setBonus($bonus) {
    $this->bonus = $bonus;
  }
  function getBonus() {
    return $this->bonus;
  }
  
  function setFiabilite($fiabilite) {
    $this->fiabilite = $fiabilite;
  }
  function getFiabilite() {
    return $this->fiabilite;
  }
  function hasFiabilite() {
    return ($this->fiabilite != "");
  }

  function setDegats($degats) {
    $this->degats = $degats;
  }
  function getDegats() {
    return $this->degats;
  }
  function hasDegats() {
    return ($this->degats != "");
  }
  function setAcceleration($acceleration) {
    $this->acceleration = $acceleration;
  }
  function getAcceleration() {
    return $this->acceleration;
  }
  function hasAcceleration() {
    return ($this->acceleration != "");
  }
  function setPrix($prix) {
    $this->prix = $prix;
  }
  function getPrix() {
    return $this->prix;
  }
  function setPrix_achat($prix_achat) {
    $this->prix_achat = $prix_achat;
  }
  function getPrix_achat() {
    return $this->prix_achat;
  }
  function setPrix_vente($prix_vente) {
    $this->prix_vente = $prix_vente;
  }
  function getPrix_vente() {
    return $this->prix_vente;
  }
  function setPrix_repare($prix_repare) {
    $this->prix_repare = $prix_repare;
  }
  function getPrix_repare() {
    return $this->prix_repare;
  }
  function setLevel($level) {
    $this->level = $level;
  }
  function getLevel() {
    return $this->level;
  }
  function setCmp($cmp) {
    $this->cmp = $cmp;
  }
  function getCmp() {
    return $this->cmp;
  }
}

?>