<?php
/**
 * SessionManager.php : Manager pour la session
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe & Thierry Bousquet.
 *
 * Ce logiciel est distribu selon les termes de la GNU General Public License v2.
 */

 class SessionManager {
   // Constructeur
   function SessionManager() {
     if (!isset($_SESSION) || !isset($_SESSION["user_name"])) {
       session_start();
     }
   }

   function start() {
     session_start();
   }
   
   function restart() {
     $_SESSION = array();
     session_start();
   }
   
   // Support Session pour les urls
   function parseURL($url,$vars="") {
     return $url."?".session_name()."=".session_id()."&amp;date=".microtime().($vars != "" ? "&amp;".$vars : ""); 
   }
   
   // Sauvegarde d'une variable
   function save($name,$value) {
     $_SESSION[$name]=serialize($value);
   }
   
   // Charger une variable sauvegarde
   function load($name) {
     if (isset($_SESSION[$name])) return unserialize($_SESSION[$name]);
     else return "";
   }
      
   function getId() {
     return session_id();
   }
   
   // Fermer la session
   function close() {
     $_SESSION = array();
//     session_destroy();
   }
 }
?>