<?php
/**
 * action_bagarre_contrat.php : partie mtier d'une bagarre contre un pj via un contrat de la Police
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */
  $logManager->message("action_Bagarre : debut");
  
  include_once("dao/accesseurs/Darkcity_competenceDao.php");
  include_once("dao/objets/Darkcity_competence.php");
  include_once("dao/accesseurs/Darkcity_competence_cpyDao.php");
  include_once("dao/objets/Darkcity_competence_cpy.php");
  include_once("dao/accesseurs/Darkcity_inventaireDao.php");
  include_once("dao/objets/Darkcity_inventaire.php");
  include_once("dao/accesseurs/Darkcity_xptableDao.php");
  include_once("dao/objets/Darkcity_xptable.php");
  include_once("dao/accesseurs/Darkcity_occupationDao.php");
  include_once("dao/objets/Darkcity_occupation.php");
  include_once("dao/accesseurs/Darkcity_planqueDao.php");
  include_once("dao/objets/Darkcity_planque.php");
  include_once("dao/accesseurs/Darkcity_competence_nameDao.php");
  include_once("dao/objets/Darkcity_competence_name.php");
  include_once("dao/accesseurs/Darkcity_arme_blancheDao.php");
  include_once("dao/objets/Darkcity_arme_blanche.php");
  include_once("dao/accesseurs/Darkcity_armureDao.php");
  include_once("dao/objets/Darkcity_armure.php");
  include_once("dao/accesseurs/Darkcity_bonusDao.php");
  include_once("dao/objets/Darkcity_bonus.php");

  $object_id = (isset($_POST["object_id"])?$_POST["object_id"]:"");
  $currentDate = $dateManager->getCurrentDate(); 
  
  // Les informations du joueur
  $user_name = $sessionManager->load("user_name");
  $adv_name = $sessionManager->load("adversaire");

  $competenceDao = new Darkcity_competenceDao;
  $xptableDao = new Darkcity_xptableDao;
  $inventaireDao = new Darkcity_inventaireDao;
  $cmpnameDao = new Darkcity_competence_nameDao;
  $armeDao = new Darkcity_arme_blancheDao;
  $armureDao = new Darkcity_armureDao;
  $bonusDao = new Darkcity_bonusDao;
  $occupationDao = new Darkcity_occupationDao;

  // Joueur 1 Level PHY / BGR
  $logManager->message("action_Bagarre : Joueur 1 Level PHY / BGR");
  $J1_competence = $competenceDao->getObject(&$datasource, $user_name);
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$J1_competence->getCompetence_BGR()."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $J1_level_BGR = $levelList[0]->getXptable_level();
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$J1_competence->getCompetence_PHY()."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $J1_level_PHY = $levelList[0]->getXptable_level();
  $J1_vie = $J1_competence->getCompetence_VIE();
  $J1_argent = $J1_competence->getCompetence_ARG();
  $J1_reputation = $J1_competence->getCompetence_REP();
  // Joueur 1 Occupation
  $J1_occupation = $occupationDao->getObject(&$datasource, $user_name);
  // Joueur 1 Bonus PHY / BGR
  $logManager->message("action_Bagarre : Joueur 1 Bonus PHY / BGR");
  $sql = "SELECT * FROM darkcity_inventaire WHERE inventaire_user = '".$user_name."' AND (inventaire_cmpname = 'PHY' OR inventaire_cmpname = 'BGR') AND inventaire_actif = '1';";
  $J1_inventaire = $inventaireDao->listQuery(&$datasource, $sql); 
  $J1_idxArmure = -1;
  $J1_idxArme = -1;
  for ($i = 0; $i < sizeof($J1_inventaire); $i++) {
    $armeT = $J1_inventaire[$i];
    if ($armeT->getInventaire_cmpname() == 'BGR') $J1_idxArme = $i;
    if ($armeT->getInventaire_cmpname() == 'PHY') $J1_idxArmure = $i;
  }
  $J1_arme = "";
  $J1_arme_precision = 0;
  $J1_arme_nombre = 0;
  $J1_arme_degat = 0;
  $J1_arme_bonus = 0;
  $J1_arme_pds = 0;
  $J1_arme_fiabilite = "";
  if ($J1_idxArme > -1) {
    $armeT = $J1_inventaire[$J1_idxArme];
    $arme = $armeDao->getObject(&$datasource, $armeT->getInventaire_objid());
    $J1_arme = $arme->getAblanche_name();
    $J1_arme_precision = $arme->getAblanche_precision();
    $J1_arme_nombre = $arme->getAblanche_nombre();
    $J1_arme_degats = $arme->getAblanche_degats();
    $J1_arme_bonus = $arme->getAblanche_bonus();
    $J1_arme_pds = $armeT->getInventaire_structure();
    $J1_arme_fiabilite = $arme->getAblanche_fiabilite();
  }
  $J1_armure = "";
  $J1_armure_bonus = 0;
  $J1_armure_pds = 0;
  if ($J1_idxArmure > -1) {
    $armure = $armureDao->getObject(&$datasource, $J1_inventaire[$J1_idxArmure]->getInventaire_objid());
    $J1_armure = $armure->getArmure_name();
    $J1_armure_bonus = $armure->getArmure_bonus();
    $J1_armure_pds = $J1_inventaire[$J1_idxArmure]->getInventaire_structure();
  }
  // joueur 1 bonus supplementaire
  $logManager->message("action_Bagarre : joueur 1 bonus supplementaire");
  $J1_bonus_BGR = 0;
  $bonus = $bonusDao->getObject(&$datasource, $user_name, "BGR");  
  if ($bonus->getBonus_datefin() != "" && $bonus->getBonus_datefin()>$currentDate) {
    $J1_bonus_BGR = $bonus->getBonus_bonus();
  }
  $J1_bonus_PHY = 0;
  $bonus = $bonusDao->getObject(&$datasource, $user_name, "PHY");  
  if ($bonus->getBonus_datefin() != "" && $bonus->getBonus_datefin()>$currentDate) {
    $J1_bonus_PHY = $bonus->getBonus_bonus();
  }
  

  // On rcupre les comptences
  if (!$menuDataBean->isOccupe()) {
    $competence_cpyDao = new Darkcity_competence_cpyDao;
    $competence_cpy = $competence_cpyDao->getObject(&$datasource, $adv_name); 
    if ($competence_cpy->getCompetence_VIE() != "" && $competence_cpy->getCompetence_VIE() > 0) {
      $competence = new Darkcity_competence;
      $competence->setCompetence_user($competence_cpy->getCompetence_user());
      $competence->setCompetence_BGR($competence_cpy->getCompetence_TIR());
      $competence->setCompetence_BGR($competence_cpy->getCompetence_BGR());
      $competence->setCompetence_PHY($competence_cpy->getCompetence_PHY());
      $competence->setCompetence_REC($competence_cpy->getCompetence_REC());
      $competence->setCompetence_SEC($competence_cpy->getCompetence_SEC());
      $competence->setCompetence_RPR($competence_cpy->getCompetence_RPR());
      $competence->setCompetence_PIL($competence_cpy->getCompetence_PIL());
      $competence->setCompetence_MED($competence_cpy->getCompetence_MED());
      $competence->setCompetence_PER($competence_cpy->getCompetence_PER());
      $competence->setCompetence_REP($competence_cpy->getCompetence_REP());
      $competence->setCompetence_VIE($competence_cpy->getCompetence_VIE());
      $competence->setCompetence_ARG($competence_cpy->getCompetence_ARG());
      $competenceDao = new Darkcity_competenceDao;
      $competenceDao->save(&$datasource, $competence); 
      $competence_cpyDao->delete(&$datasource, $competence_cpy); 
    }
  }
  // Joueur 2 Level PHY / BGR
  $logManager->message("action_Bagarre : Joueur 2 Level PHY / BGR");
  $J2_competence = $competenceDao->getObject(&$datasource, $adv_name); 
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$J2_competence->getCompetence_BGR()."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $J2_level_BGR = $levelList[0]->getXptable_level();
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$J2_competence->getCompetence_PHY()."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $J2_level_PHY = $levelList[0]->getXptable_level();
  $J2_vie = $J2_competence->getCompetence_VIE();
  $J2_argent = $J2_competence->getCompetence_ARG();
  
  // Joueur 2 Bonus PHY / BGR
  $logManager->message("action_Bagarre : Joueur 2 Bonus PHY / BGR");
  $sql = "SELECT * FROM darkcity_inventaire WHERE inventaire_user = '".$adv_name."' AND (inventaire_cmpname = 'PHY' OR inventaire_cmpname = 'BGR') AND inventaire_actif = '1';";
  $J2_inventaire = $inventaireDao->listQuery(&$datasource, $sql); 
  $J2_idxArmure = -1;
  $J2_idxArme = -1;
  for ($i = 0; $i < sizeof($J2_inventaire); $i++) {
    $armeT = $J2_inventaire[$i];
    if ($armeT->getInventaire_cmpname() == 'BGR') $J2_idxArme = $i;
    if ($armeT->getInventaire_cmpname() == 'PHY') $J2_idxArmure = $i;
  }
  $J2_arme = "";
  $J2_arme_precision = 0;
  $J2_arme_nombre = 0;
  $J2_arme_degat = 0;
  $J2_arme_bonus = 0;
  $J2_arme_pds = 0;
  $J2_arme_fiabilite = "";
  if ($J2_idxArme > -1) {
    $armeT = $J2_inventaire[$J2_idxArme];
    $arme = $armeDao->getObject(&$datasource, $armeT->getInventaire_objid());
    $J2_arme = $arme->getAblanche_name();
    $J2_arme_precision = $arme->getAblanche_precision();
    $J2_arme_nombre = $arme->getAblanche_nombre();
    $J2_arme_degats = $arme->getAblanche_degats();
    $J2_arme_bonus = $arme->getAblanche_bonus();
    $J2_arme_pds = $J2_inventaire[$J2_idxArme]->getInventaire_structure();
    $J2_arme_fiabilite = $arme->getAblanche_fiabilite();
  }
  $J2_armure = "";
  $J2_armure_bonus = 0;
  $J2_armure_pds = 0;
  if ($J2_idxArmure > -1) {
    $armure = $armureDao->getObject(&$datasource, $J2_inventaire[$J2_idxArmure]->getInventaire_objid());
    $J2_armure = $armure->getArmure_name();
    $J2_armure_bonus = $armure->getArmure_bonus();
    $J2_armure_pds = $J2_inventaire[$J2_idxArmure]->getInventaire_structure();
  }
  // Joueur 2 Occupation
  $J2_occupation = $occupationDao->getObject(&$datasource, $adv_name);
  // joueur 2 bonus supplementaire
  $logManager->message("action_Bagarre : Joueur 2 bonus supplementaire");
  $J2_bonus_BGR = 0;
  $bonus = $bonusDao->getObject(&$datasource, $adv_name, "BGR");  
  if ($bonus->getBonus_datefin() != "" && $bonus->getBonus_datefin()>$currentDate) {
    $J2_bonus_BGR = $bonus->getBonus_bonus();
  }
  $J2_bonus_PHY = 0;
  $bonus = $bonusDao->getObject(&$datasource, $adv_name, "PHY");  
  if ($bonus->getBonus_datefin() != "" && $bonus->getBonus_datefin()>$currentDate) {
    $J2_bonus_PHY = $bonus->getBonus_bonus();
  }

  $continuer_cbt = $TRUE;   
 
  $logManager->message("action_Bagarre : Texte d'intro");
  $texte=$texte."Le combat s'engage entre ".$user_name." et ".$adv_name."\n\n";
  $texte=$texte."$user_name :\n";
  $texte=$texte."* Niveau de Bagarre 1D".($J1_level_BGR+5)."+".($J1_arme_precision+$J1_bonus_BGR).".\n";
  $texte=$texte."* Niveau de physique 1D".($J1_level_PHY+5)."+".($J1_armure_bonus+$J1_bonus_PHY).".\n";
  if ($J1_arme != "") {
    $texte=$texte."* Il se bat avec ".$J1_arme." infligeant ".$J1_arme_nombre."D".$J1_arme_degats."+".$J1_arme_bonus." de dgts.\n";
  }
  else  {
    $texte=$texte."* Il se bat  main nues infligeant 1D3 de dgts.\n";
  }
  if ($J1_armure != "") {
    $texte=$texte."* Il porte galement ".$J1_armure." pour se protger.\n";
  }
  $texte=$texte."\n$adv_name :\n";
  $texte=$texte."* Niveau de Bagarre 1D".($J2_level_BGR+5)."+".($J2_arme_precision+$J2_bonus_BGR).".\n";
  $texte=$texte."* Niveau de physique 1D".($J2_level_PHY+5)."+".($J2_armure_bonus+$J2_bonus_PHY).".\n";
  if ($J2_arme != "") {
    $texte=$texte."* Il se bat avec ".$J2_arme." infligeant ".$J2_arme_nombre."D".$J2_arme_degats."+".$J2_arme_bonus." de dgts.\n";
  }
  else  {
    $texte=$texte."* Il se bat  main nues infligeant 1D3 de dgts.\n";
  }
  if ($J2_armure != "") {
    $texte=$texte."* Il porte galement ".$J2_armure." pour se protger.\n";
  }
 
  $J1_xp_BGR = 0;
  $J1_xp_PHY = 0;
  $J2_xp_BGR = 0;
  $J2_xp_PHY = 0;
  $J1_total_degats = 0;
  $J2_total_degats = 0;
  $round = 1;
  $continu_combat = $TRUE;
  $abandon = "";

  // Le combat
  while ($continu_combat) {  
    $logManager->message("action_Bagarre : Round ".$round);
    $texte=$texte."\nRound ".$round." :\n";
    $texte=$texte.$user_name." porte un coup de ".($J1_arme != "" && $J1_arme_pds > 0 ? $J1_arme : "poing").", ";
      $attaqueJ1 = $systemeDes->jeterOpposition($J1_level_BGR, $J1_arme_bonus+$J1_bonus_BGR, 0, $J2_level_PHY, $J2_armure_bonus+$J2_bonus_PHY, 0);
      $logManager->message("action_Bagarre : ".$user_name.($attaqueJ1 > 0 ? " touche." : " rate")); 
      if ($attaqueJ1 > 0) {
        $degats = $systemeDes->jeterN(($J1_arme != "" && $J1_arme_pds > 0 ? $J1_arme_nombre : 1), ($J1_arme != "" && $J1_arme_pds > 0 ? $J1_arme_degats : 3)) +  ($J1_arme != "" && $J1_arme_pds > 0 ? $J1_arme_bonus : 0);
        $texte=$texte."il touche ".$adv_name." et lui inflige ".$degats." points de dgats.";
        $J2_vie -= $degats;
        $J1_total_degats += $degats;
        $J1_xp_BGR += $systemeDes->calculeXP($attaqueJ1,$J1_level_BGR, $J2_level_PHY);
        $continu_combat = ($J2_vie >= 25);
        if ($J2_armure != "" && $J2_armure_pds > 0) {
          $J2_armure_pds -= 1;
          if ($J2_armure_pds <= 0) {
            $J2_armure_pds = 0;
            $J2_armure_bonus = 0;
            $texte=$texte." ".$J2_armure." de ".$adv_name." se casse et devient inefficace.";        
          }
        }
        if (!$continu_combat) {
          $abandon = "J2";
          if ($J2_vie < 1) $J2_vie = 1;
          $texte=$texte."\n".$adv_name." tombe vanouie, le combat est termin.";        
        }     
      }
      else {
        $texte=$texte."il rate ".$adv_name.".";
        $J2_xp_PHY += $systemeDes->calculeXP(abs($attaqueJ1), $J2_level_PHY, $J1_level_BGR);
        if ($J1_arme != "" && $J1_arme_pds > 0) {
          if ($systemeDes->jeterN(1,($J1_arme_fiabilite == "F" ? 2 : ($J1_arme_fiabilite == "S" ? 3 : 4))) == 1) {
            $dg = $systemeDes->jeterN(1, 6);
            $J1_arme_pds -= $dg;
            $texte=$texte." ".$J1_arme." de ".$user_name." prend un choc de $dg points de structure.";        
            if ($J1_arme_pds <= 0) {
              $J1_arme_pds = 0;
              $J1_arme_precision = 0;
              $texte=$texte." ".$J1_arme." de ".$user_name." se casse et devient inefficace.";        
            }
          }
        }
      }
    if ($continu_combat) {
      $texte=$texte."\n".$adv_name." porte un coup de ".($J2_arme != "" && $J2_arme_pds > 0 ? $J2_arme : "poing").", ";
      $attaqueJ2 = $systemeDes->jeterOpposition($J2_level_BGR, $J2_arme_bonus+$J2_bonus_BGR, 0, $J1_level_PHY, $J1_armure_bonus+$J1_bonus_PHY, 0);
      $logManager->message("action_Bagarre : ".$adv_name.($attaqueJ2 > 0 ? " touche." : " rate")); 
      if ($attaqueJ2 > 0) {
        $degats = $systemeDes->jeterN(($J2_arme != "" && $J2_arme_pds > 0 ? $J2_arme_nombre : 1), ($J2_arme != "" && $J2_arme_pds > 0 ? $J2_arme_degats : 3)) +  ($J2_arme != "" && $J2_arme_pds > 0 ? $J2_arme_bonus : 0);
        $texte=$texte."il touche ".$user_name." et lui inflige ".$degats." points de dgats.";
        $J1_vie -= $degats;
        $J2_total_degats += $degats;
        $J2_xp_BGR += $systemeDes->calculeXP($attaqueJ2, $J2_level_BGR, $J1_level_PHY);
        $continu_combat = ($J1_vie >= 25);
        if ($J1_armure != "" && $J1_armure_pds > 0) {
          $J1_armure_pds -= 1;
          if ($J1_armure_pds <= 0) {
            $J1_armure_pds = 0;
            $J1_armure_bonus = 0;
            $texte=$texte." ".$J1_armure." de ".$user_name." se casse et devient inefficace.";        
          }
        }
        if (!$continu_combat) {
          $abandon = "J1";
          if ($J1_vie < 1) $J1_vie = 1;
          $texte=$texte."\n".$user_name." tombe vanouie, le combat est termin.";        
        }
      }
      else {
        $texte=$texte."il rate ".$user_name.".";
        $J1_xp_PHY += $systemeDes->calculeXP(abs($attaqueJ2), $J1_level_PHY, $J2_level_BGR);
        if ($J2_arme != "" && $J2_arme_pds > 0) {
          if ($systemeDes->jeterN(1,($J2_arme_fiabilite == "F" ? 2 : ($J2_arme_fiabilite == "S" ? 3 : 4))) == 1) {
            $dg = $systemeDes->jeterN(1, 6);
            $J2_arme_pds -= $dg;
            $texte=$texte." ".$J2_arme." de ".$adv_name." prend un choc de $dg points de structure.";        
            if ($J2_arme_pds <= 0) {
              $J2_arme_pds = 0;
              $J2_arme_precision = 0;
              $texte=$texte." ".$J2_arme." de ".$adv_name." se casse et devient inefficace.";        
            }
          }
        }
      }
    }  
    $texte=$texte."\n";
    $continu_combat = ($continu_combat && $round < $NB_ROUNDS);
    $round++;
  }
  $texte=$texte."\nFin du combat :\n";
  $texte=$texte."Dgats infligs par ".$user_name." : ".$J1_total_degats."\n";
  $texte=$texte."Dgats infligs par ".$adv_name." : ".$J2_total_degats."\n";
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".abs($J1_reputation)."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $J1levelREP = $levelList[0]->getXptable_level();
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".abs($J2_reputation)."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $J2levelREP = $levelList[0]->getXptable_level();
  $vainqueur = "";
  if ($J1_total_degats == $J2_total_degats && $abandon == "") {
    $texte=$texte."Egalit.\n";
    $gain = 0;
    $xp_reputation = 0;
  }
  else if (($J1_total_degats > $J2_total_degats && $abandon != "J1") || $abandon == "J2") {
    $texte=$texte."Vainqueur ".$user_name.".\n";
    $xp_reputation = 2 * $systemeDes->calculeXP(10, 1, $J2levelREP);
    $vainqueur = "J1";
  }
  else {
    $texte=$texte."Vainqueur ".$adv_name.".\n";
    $xp_reputation = -2 * $systemeDes->calculeXP(10, 1, $J1levelREP);
    $vainqueur = "J2";
  }

  // On sauvegarde l'inventaire de J1
  if ($J1_idxArme > -1) {
    $objet = $J1_inventaire[$J1_idxArme];
    $objet->setInventaire_structure($J1_arme_pds);
    if ($J1_arme_pds == 0) {
      $objet->setInventaire_actif($FALSE);
    }
    $inventaireDao->save(&$datasource, $objet);
  }
  if ($J1_idxArmure > -1) {
    $objet = $J1_inventaire[$J1_idxArmure];
    $objet->setInventaire_structure($J1_armure_pds);
    if ($J1_armure_pds == 0) {
      $objet->setInventaire_actif($FALSE);
    }
    $inventaireDao->save(&$datasource, $objet);
  }  
  
  // On sauvegarde l'inventaire de J2
  if ($J2_idxArme > -1) {
    $objet = $J2_inventaire[$J2_idxArme];
    $objet->setInventaire_structure($J2_arme_pds);
    if ($J2_arme_pds == 0) {
      $objet->setInventaire_actif($FALSE);
    }
    $inventaireDao->save(&$datasource, $objet);
  }
  if ($J2_idxArmure > -1) {
    $objet = $J2_inventaire[$J2_idxArmure];
    $objet->setInventaire_structure($J2_armure_pds);
    if ($J2_armure_pds == 0) {
      $objet->setInventaire_actif($FALSE);
    }
    $inventaireDao->save(&$datasource, $objet);
  }
  
  $logManager->message("action_Bagarre : \n".$texte.$texteJ1); 
  $logManager->message("action_Bagarre : fin");
?>