<?php
/**
 * action_loisir.php : partie mtier du centre de loisir
 *
 * Date    : 31/05/2009
 * Auteur  : Thierry Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */
  $logManager->message("action_loisir : debut");
  
  include_once("dao/accesseurs/Darkcity_competenceDao.php");
  include_once("dao/objets/Darkcity_competence.php");
  include_once("dao/accesseurs/Darkcity_competence_cpyDao.php");
  include_once("dao/objets/Darkcity_competence_cpy.php");
  include_once("dao/accesseurs/Darkcity_xptableDao.php");
  include_once("dao/objets/Darkcity_xptable.php");
  include_once("dao/accesseurs/Darkcity_occupationDao.php");
  include_once("dao/objets/Darkcity_occupation.php");
  include_once("dao/accesseurs/Darkcity_competence_nameDao.php");
  include_once("dao/objets/Darkcity_competence_name.php");
  include_once("dao/accesseurs/Darkcity_activiteDao.php");
  include_once("dao/objets/Darkcity_activite.php");

  $activiteKey = (isset($_POST["activiteKey"])?$_POST["activiteKey"]:"");
  $duree = (isset($_POST["duree"])?$_POST["duree"]:"");
  $user_name = $sessionManager->load("user_name");

  $continuer = $TRUE;

  $competenceDao = new Darkcity_competenceDao;
  $competence = $competenceDao->getObject(&$datasource, $user_name); 

  $occupationDao = new Darkcity_occupationDao;
  $occupation = $occupationDao->getObject(&$datasource, $user_name);
  
  $activiteDao = new Darkcity_activiteDao;
  $activite = $activiteDao->getObject(&$datasource, $activiteKey); 
  
  $logManager->message("action_reparer : jet reussis");
  $cmpnameDao = new Darkcity_competence_nameDao;
  $cmpname = $cmpnameDao->getObject(&$datasource, $activite->getCmpname_name());

  $cout = round($activite->getXptable_level() / 10) * 10;
  $xp = round(($activite->getXptable_level() > 5 ? $activite->getXptable_level() : 5) * $XP_MULTIPLIEUR * $duree/15);
  $depense = ($cout + $SALAIRE) * $duree/15;
  $cmp = $activite->getCmpname_name();
  

  //* contrle du niveau du portefeuille
  if ($competence->getCompetence_ARG() < $depense) {
     $infoManager->setMessage("Vous devez avoir au moins ".$depense." $ en poche.");
         $continuer = $FALSE;
  } 
  else if ($competence->getCompetence_VIE() < 25) {
     $infoManager->setMessage("Vous tes actuellement trop bless pour pouvoir vous entrainer.");
         $continuer = $FALSE;
  } 
  else {
    $competence_cpyDao = new Darkcity_competence_cpyDao;
    $competence_cpy = new Darkcity_competence_cpy;
    $competence_cpy->setCompetence_user($competence->getCompetence_user());
  
    $competence_cpy->setCompetence_TIR($competence->getCompetence_TIR() + ($cmp == "TIR" ? $xp : 0));
    $competence_cpy->setCompetence_BGR($competence->getCompetence_BGR() + ($cmp == "BGR" ? $xp : 0));
    $competence_cpy->setCompetence_PHY($competence->getCompetence_PHY() + ($cmp == "PHY" ? $xp : 0));
    $competence_cpy->setCompetence_REC($competence->getCompetence_REC() + ($cmp == "REC" ? $xp : 0));
    $competence_cpy->setCompetence_SEC($competence->getCompetence_SEC() + ($cmp == "SEC" ? $xp : 0));
    $competence_cpy->setCompetence_RPR($competence->getCompetence_RPR() + ($cmp == "RPR" ? $xp : 0));
    $competence_cpy->setCompetence_PIL($competence->getCompetence_PIL() + ($cmp == "PIL" ? $xp : 0));
    $competence_cpy->setCompetence_MED($competence->getCompetence_MED() + ($cmp == "MED" ? $xp : 0));
    $competence_cpy->setCompetence_PER($competence->getCompetence_PER() + ($cmp == "PER" ? $xp : 0));
    $competence_cpy->setCompetence_REP($competence->getCompetence_REP());
    $competence_cpy->setCompetence_VIE($competence->getCompetence_VIE());
    $competence_cpy->setCompetence_ARG($competence->getCompetence_ARG() - $depense);
    $competence_cpyDao->create(&$datasource, $competence_cpy);
  
    // On occupe le joueur
    $occupation->setOccupation_occupation("Vous tes en train de vous entrainer en ".$activite->getactivite_libelle());
    $delai = $duree * $MINUTE;
    $date = $dateManager->getFutureDate($delai);
    $occupation->setOccupation_datefin($dateManager->getFutureDate($delai));
    $occupationDao->save(&$datasource, $occupation);
      
    // On envoie un message au joueur
    $title = htmlspecialchars("Vous avez suivi un entrainement de ", ENT_QUOTES).$activite->getactivite_libelle();
    $content = htmlspecialchars('Vous suivi une leon durant '.$duree.' minutes de ',ENT_QUOTES).$activite->getactivite_libelle().".\n".
      htmlspecialchars('Cela vous permet de gagner : ', ENT_QUOTES).$xp.htmlspecialchars(' points d\'expriences en ', ENT_QUOTES).$cmpname->getCmpname_title()."\n".
      htmlspecialchars('Vous avez dpens ', ENT_QUOTES).$depense.htmlspecialchars(' $.', ENT_QUOTES)."\n";
    $messageManager->sendMessage('', $user_name, $title, $content, $date);
  }

  $logManager->message("action_travailler : fin");
?>