 <?php 
/**
 * action_soigner.php : partie mtier de soins d'un personnage
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */  
  $logManager->message("action_soigner : debut");
  
  include_once("dao/accesseurs/Darkcity_competenceDao.php");
  include_once("dao/objets/Darkcity_competence.php");
  include_once("dao/accesseurs/Darkcity_competence_cpyDao.php");
  include_once("dao/objets/Darkcity_competence_cpy.php");
  include_once("dao/accesseurs/Darkcity_inventaireDao.php");
  include_once("dao/objets/Darkcity_inventaire.php");
  include_once("dao/accesseurs/Darkcity_inventaire_cpyDao.php");
  include_once("dao/accesseurs/Darkcity_objetDao.php");
  include_once("dao/objets/Darkcity_objet.php");
  include_once("dao/accesseurs/Darkcity_xptableDao.php");
  include_once("dao/objets/Darkcity_xptable.php");
  include_once("dao/accesseurs/Darkcity_occupationDao.php");
  include_once("dao/objets/Darkcity_occupation.php");
  include_once("dao/accesseurs/Darkcity_competence_nameDao.php");
  include_once("dao/objets/Darkcity_competence_name.php");
  include_once("dao/accesseurs/Darkcity_planqueDao.php");
  include_once("dao/objets/Darkcity_planque.php");

  // Rcupration des variables
  $user_name = $sessionManager->load("user_name");

  // On rcupre l'objet dans l'inventaire
  $logManager->message("action_soigner : charger competence");
  $competenceDao = new Darkcity_competenceDao;
  $competence = $competenceDao->getObject(&$datasource, $user_name);
  $planqueDao = new Darkcity_planqueDao;
  $planque = $planqueDao->getObject(&$datasource, $user_name);
  
  // On recupre un objet de MED actif
  $logManager->message("action_soigner : charger inventaire");
  $inventaireDao = new Darkcity_inventaireDao;
  $inventaire_cpyDao = new Darkcity_inventaire_cpyDao;
  $sql = "SELECT * FROM darkcity_inventaire WHERE inventaire_user = '".$user_name."' AND inventaire_cmpname = 'MED' AND inventaire_actif = '1';";
  $inventaireList = $inventaireDao->listQuery(&$datasource, $sql); 

  $logManager->message("action_soigner : charger occupation");
  $occupationDao = new Darkcity_occupationDao;
  $occupation = $occupationDao->getObject(&$datasource, $user_name);
  
  if ($competence->getCompetence_VIE() == 100) {
    $infoManager->setMessage("Vous n'avez aucune blessure  soigner.");
  }
  else if (sizeof($inventaireList) == 0) {
    $infoManager->setMessage("Vous devez avoir au moins une trousse  pharmacie active dans votre inventaire pour vous soigner.");
  }
  else if ($occupation->getOccupation_soins() > $dateManager->getCurrentDate()) {
    $infoManager->setMessage("Vous avez dja reu des soins.<br/>Vous pourrez retenter de vous soigner ".$dateManager->dateToString($occupation->getOccupation_soins()).".");
  }
  else {
    // On va chercher le level correspondant
    $logManager->message("action_soigner : charger xptable");
    $xptableDao = new Darkcity_xptableDao;
    $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$competence->getCompetence_MED()."' ORDER BY xptable_level DESC;";
    $levelList = $xptableDao->listQuery(&$datasource, $sql); 
    $level = $levelList[0]->getXptable_level();
    
    // On va chercher le bonus
    $logManager->message("action_soigner : charger bonus");
    $objetDao = new Darkcity_objetDao;
    $obj = $objetDao->getObject(&$datasource, $inventaireList[0]->getInventaire_objid()); 
    $bonus = $obj->getObjet_bonus();
    
    $bonus = $bonus + $planque->getPlanque_confort();
    
    // On dterminde la dificult
    $diff = round((100 - $competence->getCompetence_VIE()) / 2);
    
    // Jet d'opposition
    $logManager->message("action_soigner : jet");
    $resultat = $systemeDes->jeterDifficulte($level, $bonus, 0, $diff);
    $logManager->message("action_reparer : ".$resultat.", ".$diff);
    if ($resultat > $diff) $resultat  = $diff;
    $xp = $systemeDes->calculeXP($resultat, $level, $diff);
    
    // on met  jour l'inventaire 
    $logManager->message("action_soigner : update inventaire");
    $inventaireList[0]->setInventaire_structure($inventaireList[0]->getInventaire_structure()-1);
    if ($inventaireList[0]->getInventaire_structure() == 0) {
    	$inventaireList[0]->setInventaire_actif($FALSE);
    }
    $inventaire_cpyDao->create(&$datasource, $inventaireList[0]);
    
    if ($resultat > 0) {
      $logManager->message("action_soigner : jet reussis");
      $cmpnameDao = new Darkcity_competence_nameDao;
      $cmpname = $cmpnameDao->getObject(&$datasource, "VIE"); 
      $cmpname2 = $cmpnameDao->getObject(&$datasource, "MED"); 

      // On envoie le message de russite
      $title = htmlspecialchars("Vous vous tes soign de ".$resultat." points de ", ENT_QUOTES).$cmpname->getCmpname_title();
      $content = htmlspecialchars('Vous dcidez de vous appliquer des soins, pour cela vous utilisez ', ENT_QUOTES).$obj->getObjet_name().".".
      htmlspecialchars('La blessure ne vous semble pas trop grave, et vous russissez  vous soigner de '.$resultat.' points de ', ENT_QUOTES).$cmpname->getCmpname_title().".".
      htmlspecialchars(' Vous gagnez de plus '.$xp." points d'exprience en ", ENT_QUOTES).$cmpname2->getCmpname_title().".";
      
      $competence_cpyDao = new Darkcity_competence_cpyDao;
      $competence_cpy = new Darkcity_competence_cpy;
      $competence_cpy->setCompetence_user($competence->getCompetence_user());
      $competence_cpy->setCompetence_TIR($competence->getCompetence_TIR());
      $competence_cpy->setCompetence_BGR($competence->getCompetence_BGR());
      $competence_cpy->setCompetence_PHY($competence->getCompetence_PHY());
      $competence_cpy->setCompetence_REC($competence->getCompetence_REC());
      $competence_cpy->setCompetence_SEC($competence->getCompetence_SEC());
      $competence_cpy->setCompetence_RPR($competence->getCompetence_RPR());
      $competence_cpy->setCompetence_PIL($competence->getCompetence_PIL());
      $competence_cpy->setCompetence_MED($competence->getCompetence_MED() + $xp);
      $competence_cpy->setCompetence_PER($competence->getCompetence_PER());
      $competence_cpy->setCompetence_REP($competence->getCompetence_REP());
      $competence_cpy->setCompetence_VIE($competence->getCompetence_VIE() + $resultat);
      $competence_cpy->setCompetence_ARG($competence->getCompetence_ARG());
      $competence_cpyDao->create(&$datasource, $competence_cpy);
      $tm = round($level / 10);
      if ($tm == 0) $tm = 0.5;
      $delai = round(($resultat / $tm) * $MINUTE);
      $date = $dateManager->getFutureDate($delai); 
      
      $messageManager->sendMessage('', $user_name, $title, $content, $date);
      $logManager->message("action_soigner ");
      
      $logManager->message("action_soigner : update competence");
/*      
      $competence->setCompetence_VIE($competence->getCompetence_VIE() + $resultat);
      $competence->setCompetence_MED($competence->getCompetence_MED() + $xp);
      $competenceDao->save(&$datasource, $competence);
*/      
      $occupation->setOccupation_datefin($date);
      $occupation->setOccupation_occupation("Vous tes actuellement en train de vous soigner");
      $logManager->message("action_soigner : update occupation => ".$occupation->toString());
      $occupationDao->save(&$datasource, $occupation);
 
    }
    else {
      $logManager->message("action_soigner : jet rate");

      // On envoie le message d'echec
      $title = htmlspecialchars("Vous chouez dans votre tentative de soins", ENT_QUOTES);
      $content = htmlspecialchars('Vous dcidez de vous appliquer des soins, pour cela vous utilisez ', ENT_QUOTES).$obj->getObjet_name().".".
      (abs($resultat) > $level ?
        htmlspecialchars('La blessure vous semble pas trop grave, cependant vous chouez dans votre tentative.', ENT_QUOTES) :
        htmlspecialchars('La blessure vous semble peut tre au dela de vos comptences, et effectivement vous chouez dans votre tentative.', ENT_QUOTES)
       );
      $messageManager->sendMessage('', $user_name, $title, $content, $dateManager->getCurrentDate());
      $logManager->message("action_soigner ");

    } 
  } 
  $logManager->message("action_soigner : fin");
   
?>