<?php
/**
 * action_travailler.php : partie mtier de travail dans la zone d'affaire
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */
  $logManager->message("action_travailler : debut");
  
  include_once("dao/accesseurs/Darkcity_competenceDao.php");
  include_once("dao/objets/Darkcity_competence.php");
  include_once("dao/accesseurs/Darkcity_competence_cpyDao.php");
  include_once("dao/objets/Darkcity_competence_cpy.php");
  include_once("dao/accesseurs/Darkcity_xptableDao.php");
  include_once("dao/objets/Darkcity_xptable.php");
  include_once("dao/accesseurs/Darkcity_occupationDao.php");
  include_once("dao/objets/Darkcity_occupation.php");
  include_once("dao/accesseurs/Darkcity_competence_nameDao.php");
  include_once("dao/objets/Darkcity_competence_name.php");
  include_once("dao/accesseurs/Darkcity_metierDao.php");
  include_once("dao/objets/Darkcity_metier.php");

  $metierKey = (isset($_POST["metierKey"])?$_POST["metierKey"]:"");
  $duree = (isset($_POST["duree"])?$_POST["duree"]:"");
  $user_name = $sessionManager->load("user_name");

  $competenceDao = new Darkcity_competenceDao;
  $competence = $competenceDao->getObject(&$datasource, $user_name); 

  $occupationDao = new Darkcity_occupationDao;
  $occupation = $occupationDao->getObject(&$datasource, $user_name);
  
  $metierDao = new Darkcity_metierDao;
  $metier = $metierDao->getObject(&$datasource, $metierKey); 
  
  $logManager->message("action_reparer : jet reussis");
  $cmpnameDao = new Darkcity_competence_nameDao;
  $cmpname = $cmpnameDao->getObject(&$datasource, $metier->getCmpname_name());

  $bonusSal = round($metier->getXptable_level() / 10) * 15;
  $xp = ($metier->getXptable_level() > 5 ? $metier->getXptable_level() : 5) * $XP_MULTIPLIEUR * 4 * $duree;
  $gain = ($bonusSal + $SALAIRE) * $duree;
  $cmp = $metier->getCmpname_name();
  
  $competence_cpyDao = new Darkcity_competence_cpyDao;
  $competence_cpy = new Darkcity_competence_cpy;
  $competence_cpy->setCompetence_user($competence->getCompetence_user());
  
  $competence_cpy->setCompetence_TIR($competence->getCompetence_TIR() + ($cmp == "TIR" ? $xp : 0));
  $competence_cpy->setCompetence_BGR($competence->getCompetence_BGR() + ($cmp == "BGR" ? $xp : 0));
  $competence_cpy->setCompetence_PHY($competence->getCompetence_PHY() + ($cmp == "PHY" ? $xp : 0));
  $competence_cpy->setCompetence_REC($competence->getCompetence_REC() + ($cmp == "REC" ? $xp : 0));
  $competence_cpy->setCompetence_SEC($competence->getCompetence_SEC() + ($cmp == "SEC" ? $xp : 0));
  $competence_cpy->setCompetence_RPR($competence->getCompetence_RPR() + ($cmp == "RPR" ? $xp : 0));
  $competence_cpy->setCompetence_PIL($competence->getCompetence_PIL() + ($cmp == "PIL" ? $xp : 0));
  $competence_cpy->setCompetence_MED($competence->getCompetence_MED() + ($cmp == "MED" ? $xp : 0));
  $competence_cpy->setCompetence_PER($competence->getCompetence_PER() + ($cmp == "PER" ? $xp : 0));
  $competence_cpy->setCompetence_REP($competence->getCompetence_REP());
  $competence_cpy->setCompetence_VIE($competence->getCompetence_VIE());
  $competence_cpy->setCompetence_ARG($competence->getCompetence_ARG() + $gain);
  $competence_cpyDao->create(&$datasource, $competence_cpy);
  
  // On occupe le joueur
  $occupation->setOccupation_occupation("Vous &ecirc;tes en train de travailler en temps que ".$metier->getMetier_libelle());
  $delai = $duree * $HEURE;
  $futur = floor($delai / 8);
  $date = $dateManager->getFutureDate($delai);
  $date2 = $dateManager->getFutureDate($delai + $futur);
  $occupation->setOccupation_datefin($dateManager->getFutureDate($delai));
  $occupation->setOccupation_travail($date2);
  $occupationDao->save(&$datasource, $occupation);
      
  // On envoie un message au joueur
  $title = "Vous avez travaill&eacute; en tant que ".$metier->getMetier_libelle();
  $content = 'Vous avez travaill&eacute; durant '.$duree.' heures en tant que '.$metier->getMetier_libelle().".".
     ' Cela vous permet de gagner : '."\n".
     $xp.' points d&#39;exp&eacute;riences en '.$cmpname->getCmpname_title()."\n".
     $gain.htmlspecialchars(' $ de salaire.', ENT_QUOTES)."\n";
  $messageManager->sendMessage('', $user_name, $title, $content, $date);
  
  $logManager->message("action_travailler : fin");
?>