 <?php 
/**
 * init_armurier_tir.php : partie mtier de l'armurier (armures)
 *
 * Date    : 31/05/2009
 * Auteur  : Thierry Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */    
  
  $logManager->message("init_armurier : debut");
  
  include_once("dao/accesseurs/Darkcity_userDao.php");
  include_once("dao/objets/Darkcity_user.php");
  include_once("dao/accesseurs/Darkcity_competenceDao.php");
  include_once("dao/objets/Darkcity_competence.php");
  include_once("dao/accesseurs/Darkcity_competence_cpyDao.php");
  include_once("dao/objets/Darkcity_competence_cpy.php");
  include_once("dao/accesseurs/Darkcity_inventaireDao.php");
  include_once("dao/objets/Darkcity_inventaire.php");
  include_once("dao/accesseurs/Darkcity_inventaire_cpyDao.php");
  include_once("dao/objets/Darkcity_inventaire_cpy.php");
  include_once("dao/accesseurs/Darkcity_xptableDao.php");
  include_once("dao/objets/Darkcity_xptable.php");
  include_once("dao/accesseurs/Darkcity_occupationDao.php");
  include_once("dao/objets/Darkcity_occupation.php");
  include_once("dao/accesseurs/Darkcity_competence_nameDao.php");
  include_once("dao/objets/Darkcity_competence_name.php");
  include_once("dao/accesseurs/Darkcity_armureDao.php");
  include_once("dao/objets/Darkcity_armure.php");
  include_once("dao/accesseurs/Darkcity_objetDao.php");
  include_once("dao/objets/Darkcity_objet.php");
  include_once("dao/accesseurs/Darkcity_occupationDao.php");
  include_once("dao/objets/Darkcity_occupation.php");
  include_once("databean/ArmurierDataBean.php");
  include_once("databean/CompetenceDataBean.php");
  include_once("databean/InventaireDataBean.php");

  $user_name = $sessionManager->load("user_name");
  $armurierDataBean = new armurierDataBean;
  
  $logManager->message("init_armurier : table user");
  // On recupre toutes les infos du User 
  $userDao = new Darkcity_userDao;
  $joueur = $userDao->getObject(&$datasource, $user_name);
  // On alimente le DataBean pour la VUE
  $armurierDataBean->setName($joueur->getUser_name());
    
  $logManager->message("init_armurier : table occupation");
  // on rcupre son occupation
  $marchandage = $FALSE;
  $bonus = 0;
  $occupationDao = new Darkcity_occupationDao;
  $occupation = $occupationDao->getObject(&$datasource, $user_name);
  if ($occupation->getOccupation_datefin() == "" || $occupation->getOccupation_datefin() <= $dateManager->getCurrentDate()) {
    $menuDataBean->activeTous();
    $menuDataBean->setOccupe($FALSE);
    if ($occupation->getOccupation_marchandage() <= $dateManager->getCurrentDate()) {
      $marchandage = $TRUE;
      // On rcupre les bonus en PERsuasion
      $logManager->message("Recherche Bonus");
      $inventaireDao = new Darkcity_inventaireDao;
      $sql = "SELECT * FROM darkcity_inventaire WHERE inventaire_user = '".$user_name."' AND inventaire_cmpname = 'PER' AND inventaire_actif = '1';";
      $inventaireList = $inventaireDao->listQuery(&$datasource, $sql); 
      $logManager->message("Bonus trouv ? ".sizeof($inventaireList));
      if (sizeof($inventaireList) > 0) {
        $objetDao = new Darkcity_objetDao;
        $obj = $objetDao->getObject(&$datasource, $inventaireList[0]->getInventaire_objid());
        $bonus = $obj->getObjet_bonus();
      }
    }
  }
  else {
    $armurierDataBean->setMsgInfo($occupation->getOccupation_occupation());
    $armurierDataBean->setDateFin($occupation->getOccupation_datefin());
    $menuDataBean->desactiveOccupe();
    $menuDataBean->setOccupe($TRUE);
  }
  $logManager->message("Occup : ".$menuDataBean->isOccupe());
  $logManager->message("Bonus= ".$bonus);

  $logManager->message("init_armurier : rcupre competence");
  // On rcupre les comptences
  $competenceDao = new Darkcity_competenceDao;
  $competence = $competenceDao->getObject(&$datasource, $user_name);  

  //on stocke le niveau d argent
  $armurierDataBean->setPortefeuille($competence->getCompetence_ARG());
 
  // On recupre les levels 
  $xptableDao = new Darkcity_xptableDao;
  // PHY
  $comp = new CompetenceDataBean;
  $comp->setXp($competence->getCompetence_PHY());
  $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$comp->getXp()."' ORDER BY xptable_level DESC;";
  $levelList = $xptableDao->listQuery(&$datasource, $sql); 
  $lvl_PHY = ($levelList[0]->getXptable_level());
  
  $lvl_PER = 1;
  if ($marchandage == $TRUE) {
    // level pour la comptence persuasion  
    $xptableDao = new Darkcity_xptableDao;
    $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$competence->getCompetence_PER()."' ORDER BY xptable_level DESC;";
    $levelList = $xptableDao->listQuery(&$datasource, $sql);  
    $lvl_PER = $levelList[0]->getXptable_level();
    $resultat_user = $systemeDes->jeter($lvl_PER, $bonus, 0);
  }
  $logManager->message("init_armurier : marchandage =".$resultat_user);  
  
  // On rcupre les armures *********************************************
  $armureDao = new Darkcity_armureDao;
  $sql = "SELECT * FROM darkcity_armure WHERE armure_level <= '".$lvl_PHY."' ORDER BY armure_level ASC, armure_prix ASC;";
  $armeList = $armureDao->listQuery(&$datasource, $sql); 
 
  $logManager->message("init_armurier : preparation liste armures");
  $cmpnameDao = new Darkcity_competence_nameDao;
  $armureDao = new Darkcity_armureDao;
  $objetDao = new Darkcity_objetDao;
  $cmpname = $cmpnameDao->getObject(&$datasource, "PHY");  
  $xp = 0;
  for ($i = 0; $i < sizeof($armeList); $i++) {
    $armure = $armeList[$i];
    $logManager->message("init_armurier : boucle armure n".$i);
    $inventaireDataBean = new InventaireDataBean;
    $inventaireDataBean->setId($armure->getArmure_key());
    $inventaireDataBean->setActif($FALSE);    
    $inventaireDataBean->setCompetence($cmpname->getCmpname_title());
    $inventaireDataBean->setCmp($cmpname->getCmpname_name());
    $inventaireDataBean->setName($armure->getArmure_name());
    $inventaireDataBean->setDescription($armure->getArmure_description());
    $inventaireDataBean->setImage($armure->getArmure_image());
    $inventaireDataBean->setBonus($armure->getArmure_bonus());
    $inventaireDataBean->setPdsMax($armure->getArmure_structure());
    $inventaireDataBean->setPds($armure->getArmure_structure());
    $inventaireDataBean->setPrix($armure->getArmure_prix());
    $Prix_achat = $armure->getArmure_prix();
   // Calcule Marchandage
   $xp_tmp = 0;
    if ($marchandage == $TRUE) {
      $resultat = $resultat_user - $systemeDes->jeter($armure->getArmure_level(), 0, 0);
      $logManager->message("init_armurier_armure : marchander - rsultat=".$resultat);
      if ($resultat > 0) {
        $Prix_achat = $armure->getArmure_prix() - round($armure->getArmure_prix() * 0.1);
        $xp_tmp = $systemeDes->calculeXP($resultat, $lvl_PER, $armure->getArmure_level());
      }
      if ($xp_tmp > $xp) {
        $xp = $xp_tmp; 
      }
    }
    $inventaireDataBean->setPrix_achat($Prix_achat); 
    //mise a jour des infos
    $logManager->message("init_armurier : maj liste");
    $armurierDataBean->addArmure($inventaireDataBean);
  } 
  
  //Message + Sauvagerde nouvelle Xp 
  if ($xp > 0) {
    $title = htmlspecialchars("Vous reussissez  marchander les prix avec l'armurier", ENT_QUOTES);
    $content = htmlspecialchars("Vous reussissez  marchander les prix des armures avec l'armurier\n\nVous gagnez ", ENT_QUOTES).$xp." points d&#39;exprience en Persuasion.";
    $messageManager->sendMessage('', $user_name, $title, $content, $dateManager->getCurrentDate());
    $infoManager->setMessage($title);
    //sauvegarde xp
    $competence->setCompetence_PER($competence->getCompetence_PER() + $xp);
    $competenceDao->save(&$datasource, $competence);  
    //Mise a jour de l'objet PER
    if (sizeof($inventaireList) > 0) {
       $logManager->message("action_marchandage : update inventaire");
       $inventaireList[0]->setInventaire_structure($inventaireList[0]->getInventaire_structure()-1);
       if ($inventaireList[0]->getInventaire_structure() == 0) {
       	$inventaireList[0]->setInventaire_actif($FALSE);
       }
      $inventaireDao->save(&$datasource, $inventaireList[0]);
    }  
    //sauvegarde occupation
    $occupation->setOccupation_marchandage($dateManager->getFutureDate($DELAI_MARCHANDAGE));
    $occupation->setOccupation_occupation("marchandage");
    $logManager->message("init_armurier_armure : update occupation => ".$occupation->toString());
    $occupationDao->save(&$datasource, $occupation);
  }
  
  $logManager->message("init_armurier : fin");
?>