 <?php 
/**
 * init_concessionnaire_inventaire.php : partie mtier du concessionnaire (inventaire joueur)
 *
 * Date    : 31/05/2009
 * Auteur  : Thierry Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */    

  
  $logManager->message("init_concessionnaire : debut");
  
  include_once("dao/accesseurs/Darkcity_userDao.php");
  include_once("dao/objets/Darkcity_user.php");
  include_once("dao/accesseurs/Darkcity_competenceDao.php");
  include_once("dao/objets/Darkcity_competence.php");
  include_once("dao/accesseurs/Darkcity_competence_cpyDao.php");
  include_once("dao/objets/Darkcity_competence_cpy.php");
  include_once("dao/accesseurs/Darkcity_inventaireDao.php");
  include_once("dao/objets/Darkcity_inventaire.php");
  include_once("dao/accesseurs/Darkcity_inventaire_cpyDao.php");
  include_once("dao/objets/Darkcity_inventaire_cpy.php");
  include_once("dao/accesseurs/Darkcity_xptableDao.php");
  include_once("dao/objets/Darkcity_xptable.php");
  include_once("dao/accesseurs/Darkcity_occupationDao.php");
  include_once("dao/objets/Darkcity_occupation.php");
  include_once("dao/accesseurs/Darkcity_competence_nameDao.php");
  include_once("dao/objets/Darkcity_competence_name.php");
  include_once("dao/accesseurs/Darkcity_vehiculeDao.php");
  include_once("dao/objets/Darkcity_vehicule.php");
  include_once("dao/accesseurs/Darkcity_objetDao.php");
  include_once("dao/objets/Darkcity_objet.php");
  include_once("dao/accesseurs/Darkcity_occupationDao.php");
  include_once("dao/objets/Darkcity_occupation.php");
  include_once("databean/ConcessionnaireDataBean.php");
  include_once("databean/CompetenceDataBean.php");
  include_once("databean/InventaireDataBean.php");

  $user_name = $sessionManager->load("user_name");
  $concessionnaireDataBean = new concessionnaireDataBean;
  
  $logManager->message("init_concessionnaire : table user");
  // On recupre toutes les infos du User 
  $userDao = new Darkcity_userDao;
  $joueur = $userDao->getObject(&$datasource, $user_name);
  // On alimente le DataBean pour la VUE
  $concessionnaireDataBean->setName($joueur->getUser_name());

  $logManager->message("init_concessionnaire : table occupation");
  // on rcupre son occupation
  $occupationDao = new Darkcity_occupationDao;
  $occupation = $occupationDao->getObject(&$datasource, $user_name);
  if ($occupation->getOccupation_datefin() == "" || $occupation->getOccupation_datefin() <= $dateManager->getCurrentDate()) {
    $menuDataBean->activeTous();
    $menuDataBean->setOccupe($FALSE);
  }
  else {
    $concessionnaireDataBean->setMsgInfo($occupation->getOccupation_occupation());
    $concessionnaireDataBean->setDateFin($occupation->getOccupation_datefin());
    $menuDataBean->desactiveOccupe();
    $menuDataBean->setOccupe($TRUE);
  }
  $logManager->message("Occup : ".$menuDataBean->isOccupe());
  
  $logManager->message("init_concessionnaire : table competence");
  // On rcupre les comptences
  if (!$menuDataBean->isOccupe()) {
    $competence_cpyDao = new Darkcity_competence_cpyDao;
    $competence_cpy = $competence_cpyDao->getObject(&$datasource, $user_name); 
    if ($competence_cpy->getCompetence_PIL() != "" && $competence_cpy->getCompetence_PIL() > 0) {
      $competence = new Darkcity_competence;
      $competence->setCompetence_user($competence_cpy->getCompetence_user());
      $competence->setCompetence_PIL($competence_cpy->getCompetence_PIL());
      $competenceDao = new Darkcity_competenceDao;
      $competenceDao->save(&$datasource, $competence); 
      $competence_cpyDao->delete(&$datasource, $competence_cpy); 
    }
  }
  // On rcupre les comptences
  $competenceDao = new Darkcity_competenceDao;
  $competence = $competenceDao->getObject(&$datasource, $user_name);  
  
  //on stocke le niveau d argent
  $concessionnaireDataBean->setPortefeuille($competence->getCompetence_ARG());

  // On rcupre l'inventeire pour la comptence Pilotage *****************************************
  $inventaireDao = new Darkcity_inventaireDao;
  $sql = "SELECT * FROM darkcity_inventaire WHERE inventaire_user = '".$user_name."' AND inventaire_cmpname = 'PIL' ORDER BY inventaire_actif DESC, inventaire_cmpname DESC;";
  $inventaireList = $inventaireDao->listQuery(&$datasource, $sql); 

  $logManager->message("init_concessionnaire : preparation inventaire");
  $vehiculeDao = new Darkcity_vehiculeDao;
  $objetDao = new Darkcity_objetDao;
  $cmpnameDao = new Darkcity_competence_nameDao;
  for ($i = 0; $i < sizeof($inventaireList); $i++) {
    $objet = $inventaireList[$i];
    $inventaireDataBean = new InventaireDataBean;
      $inventaireDataBean->setCmp("PIL");
    $inventaireDataBean->setId($objet->getInventaire_id());
    $inventaireDataBean->setPds($objet->getInventaire_structure());
    $inventaireDataBean->setActif($objet->getInventaire_actif());
    $cmpname = $cmpnameDao->getObject(&$datasource, $objet->getInventaire_cmpname()); 
    $inventaireDataBean->setCompetence($cmpname->getCmpname_title());
  
    // Vehicules
    if ($objet->getInventaire_cmpname() == "PIL") {
    $logManager->message("init_concessionnaire : inventaire pilotage");
      $vehicule = $vehiculeDao->getObject(&$datasource, $objet->getInventaire_objid()); 
      $inventaireDataBean->setName($vehicule->getVehicule_name());
      $inventaireDataBean->setDescription($vehicule->getVehicule_description());
      $inventaireDataBean->setImage($vehicule->getVehicule_image());
      $inventaireDataBean->setBonus($vehicule->getVehicule_bonus());
      $inventaireDataBean->setAcceleration($vehicule->getVehicule_acceleration());
      $inventaireDataBean->setPdsMax($vehicule->getVehicule_structure());
      $inventaireDataBean->setCmp($cmpname->getCmpname_name());
      $inventaireDataBean->setPrix($vehicule->getVehicule_prix());
      //calcule cout de rparation 
      $Prix_repare = round($inventaireDataBean->getPrix() * 0.1);
      //calcule prix de vente
      $Prix_vente = 0;
      if (($inventaireDataBean->getPds() / $inventaireDataBean->getPdsMax()) >= 0.5) {
                     $Prix_vente = round($inventaireDataBean->getPrix() * 0.2);
      }
      if (($inventaireDataBean->getPds() / $inventaireDataBean->getPdsMax()) >= 0.75) {
                     $Prix_vente = round($inventaireDataBean->getPrix() * 0.3);
      }
      if ($inventaireDataBean->getPds() == $inventaireDataBean->getPdsMax()) {
                     $Prix_vente = round($inventaireDataBean->getPrix() * 0.5);
      }
      //mise a jour du data bean
      $inventaireDataBean->setPrix_repare($Prix_repare);
      $inventaireDataBean->setPrix_vente($Prix_vente);
    }
    $concessionnaireDataBean->addInventaire($inventaireDataBean);
  }

  $logManager->message("init_concessionnaire : fin");
?>