 <?php 
/**
 * init_marchand_inventaire.php : partie mtier du manrchand (inventaire joueur)
 *
 * Date    : 31/05/2009
 * Auteur  : Thierry Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */    
  
  $logManager->message("init_marchand : debut");
  
  include_once("dao/accesseurs/Darkcity_userDao.php");
  include_once("dao/objets/Darkcity_user.php");
  include_once("dao/accesseurs/Darkcity_competenceDao.php");
  include_once("dao/objets/Darkcity_competence.php");
  include_once("dao/accesseurs/Darkcity_competence_cpyDao.php");
  include_once("dao/objets/Darkcity_competence_cpy.php");
  include_once("dao/accesseurs/Darkcity_inventaireDao.php");
  include_once("dao/objets/Darkcity_inventaire.php");
  include_once("dao/accesseurs/Darkcity_inventaire_cpyDao.php");
  include_once("dao/objets/Darkcity_inventaire_cpy.php");
  include_once("dao/accesseurs/Darkcity_xptableDao.php");
  include_once("dao/objets/Darkcity_xptable.php");
  include_once("dao/accesseurs/Darkcity_occupationDao.php");
  include_once("dao/objets/Darkcity_occupation.php");
  include_once("dao/accesseurs/Darkcity_competence_nameDao.php");
  include_once("dao/objets/Darkcity_competence_name.php");
  include_once("dao/accesseurs/Darkcity_objetDao.php");
  include_once("dao/objets/Darkcity_objet.php");
  include_once("dao/accesseurs/Darkcity_occupationDao.php");
  include_once("dao/objets/Darkcity_occupation.php");
  include_once("databean/MarchandDataBean.php");
  include_once("databean/CompetenceDataBean.php");
  include_once("databean/InventaireDataBean.php");

  $user_name = $sessionManager->load("user_name");
  $marchandDataBean = new marchandDataBean;
  
  $logManager->message("init_marchand : table user");
  // On recupre toutes les infos du User 
  $userDao = new Darkcity_userDao;
  $joueur = $userDao->getObject(&$datasource, $user_name);
  // On alimente le DataBean pour la VUE
  $marchandDataBean->setName($joueur->getUser_name());
    
  $logManager->message("init_marchand : table occupation");
  // on rcupre son occupation
  $marchandage = $FALSE;
  $occupationDao = new Darkcity_occupationDao;
  $occupation = $occupationDao->getObject(&$datasource, $user_name);
  if ($occupation->getOccupation_datefin() == "" || $occupation->getOccupation_datefin() <= $dateManager->getCurrentDate()) {
    $menuDataBean->activeTous();
    $menuDataBean->setOccupe($FALSE);
    if ($occupation->getOccupation_marchandage() <= $dateManager->getCurrentDate()) {
      $marchandage = $TRUE;
    }
  }
  else {
    $armurierDataBean->setMsgInfo($occupation->getOccupation_occupation());
    $armurierDataBean->setDateFin($occupation->getOccupation_datefin());
    $menuDataBean->desactiveOccupe();
    $menuDataBean->setOccupe($TRUE);
  }
  $logManager->message("Occup : ".$menuDataBean->isOccupe());

  // On rcupre les comptences
  $competenceDao = new Darkcity_competenceDao;
  $competence = $competenceDao->getObject(&$datasource, $user_name);  

  //on stocke le niveau d argent
  $marchandDataBean->setPortefeuille($competence->getCompetence_ARG());

  // On rcupre l'inventeire pour les comptence MED, REC, RPR, PER, SEC ****
  $inventaireDao = new Darkcity_inventaireDao;
  $sql = "SELECT * FROM darkcity_inventaire WHERE inventaire_user = '".$user_name."' AND (inventaire_cmpname = 'MED' OR inventaire_cmpname = 'REC' OR inventaire_cmpname = 'RPR' OR inventaire_cmpname = 'PER' OR inventaire_cmpname = 'SEC') ORDER BY inventaire_actif DESC, inventaire_cmpname DESC;";
  $inventaireList = $inventaireDao->listQuery(&$datasource, $sql); 

  $logManager->message("init_inventaire : preparation inventaire");
  $objetDao = new Darkcity_objetDao;
  $cmpnameDao = new Darkcity_competence_nameDao;
  for ($i = 0; $i < sizeof($inventaireList); $i++) {
    $objet = $inventaireList[$i];
    $inventaireDataBean = new InventaireDataBean;
    $inventaireDataBean->setId($objet->getInventaire_id());
    $inventaireDataBean->setPds($objet->getInventaire_structure());
    $inventaireDataBean->setActif($objet->getInventaire_actif());
    $cmpname = $cmpnameDao->getObject(&$datasource, $objet->getInventaire_cmpname()); 
    $inventaireDataBean->setCompetence($cmpname->getCmpname_title());
    
    //spcificit des objets
    $objetDao = new Darkcity_objetDao;
    $objet = $objetDao->getObject(&$datasource, $objet->getInventaire_objid()); 
    $inventaireDataBean->setName($objet->getObjet_name());
    $inventaireDataBean->setDescription($objet->getObjet_description());
    $inventaireDataBean->setImage($objet->getObjet_image());
    $inventaireDataBean->setBonus($objet->getObjet_bonus());
    $inventaireDataBean->setPdsMax($objet->getObjet_utilisations());
    $inventaireDataBean->setCmp($cmpname->getCmpname_name());
    $inventaireDataBean->setPrix($objet->getObjet_prix());
    //calcule prix de vente
    $Prix_vente = 0;
    if ($inventaireDataBean->getPds() == $inventaireDataBean->getPdsMax()) {
      $Prix_vente = round($inventaireDataBean->getPrix() * 0.5);
    }
    $inventaireDataBean->setPrix_vente($Prix_vente);
    //mise a jour du data bean
    $marchandDataBean->addInventaire($inventaireDataBean);
  }
  
  $logManager->message("init_marchand : fin");
?>