 <?php 
/**
 * init_zoneAffaires.php : partie mtier de liste des metiers
 *
 * Date    : 31/05/2009
 * Auteur  : Philippe Bousquet 
 * Version : 1.0
 * Contact : <darkcitygame@free.fr>
 *
 * Copyright (c) 2008-2009 Philippe Bousquet & Thierry Bousquet.
 * 
 * Ce logiciel est distribu selon le termes de la GNU General Public License v2.
 */      
  $logManager->message("init_zoneAffaire : debut");
  
  include_once("dao/accesseurs/Darkcity_competenceDao.php");
  include_once("dao/objets/Darkcity_competence.php");
  include_once("dao/accesseurs/Darkcity_xptableDao.php");
  include_once("dao/objets/Darkcity_xptable.php");
  include_once("dao/accesseurs/Darkcity_occupationDao.php");
  include_once("dao/objets/Darkcity_occupation.php");
  include_once("dao/accesseurs/Darkcity_competence_nameDao.php");
  include_once("dao/objets/Darkcity_competence_name.php");
  include_once("dao/accesseurs/Darkcity_metierDao.php");
  include_once("dao/objets/Darkcity_metier.php");
  include_once("databean/MetiersDataBean.php");

  $user_name = $sessionManager->load("user_name");
  
  // dclarer les Dao
  $logManager->message("init_zoneAffaire : dclarer les Dao");
  $competenceDao = new Darkcity_competenceDao;
  $xptableDao = new Darkcity_xptableDao;
  $metierDao = new Darkcity_metierDao;
  $occupationDao = new Darkcity_occupationDao;
  $occupation = $occupationDao->getObject(&$datasource, $user_name);
  
  // Declarer le databean
  $logManager->message("init_zoneAffaire : Declarer le databean");
  $metiersDataBean = $sessionManager->load("metierList");
  if (!isset($metiersDataBean) ||$metiersDataBean == "") {
    $metiersDataBean = new MetiersDataBean;
  }
  
  if ($metiersDataBean->getDateMetier() == "" || $metiersDataBean->getDateMetier() <= $dateManager->getCurrentDate()) {
    // charger les comptences
    $logManager->message("init_zoneAffaire : charger les comptences");
    $competence = $competenceDao->getObject(&$datasource, $user_name);
  
    // Verifier les points de vies
    $continuer = $TRUE;
    if ($competence->getCompetence_VIE() < 25) {
      if ($competence->getCompetence_ARG() < 375) {
        $infoManager->setMessage("Vous tes gravement bless on vous laisse travailler juste pour que vous gagniez suffisemment d'argent pour vous soigner.");
      } 
      else {
        $infoManager->setMessage("Vous tes trop gravement bless pour travailler, on ne vous proposera aucun mtier.");
        $continuer = $FALSE;
      }
    }  
    
    // La liste des metiers
    $metiersDataBean->resetMetiers();
    
    if ($continuer) {
    // REC
    $logManager->message("init_zoneAffaire : xptable REC");
    $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$competence->getCompetence_REC()."' ORDER BY xptable_level DESC;";
    $levelList = $xptableDao->listQuery(&$datasource, $sql); 
    $level = $levelList[0]->getXptable_level();
    $logManager->message("init_zoneAffaire : metier REC");
    $sql = "SELECT * FROM darkcity_metier WHERE xptable_level <= '".$level."' AND cmpname_name ='REC' ORDER BY xptable_level DESC;";
    $metierList = $metierDao->listQuery(&$datasource, $sql); 
    $metier = $metierList[0];
    $logManager->message("init_zoneAffaire : ".$metier->getXptable_level()." => ".$metier->getMetier_libelle());
    if ($systemeDes->jeterOpposition($level, 0, 0, $metier->getXptable_level(), 0, 0) > 0) {
      $logManager->message("on ajoute le metier");
      $metiersDataBean->addMetier($metier);
    }
    // SEC
    $logManager->message("init_zoneAffaire : xptable SEC");
    $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$competence->getCompetence_SEC()."' ORDER BY xptable_level DESC;";
    $levelList = $xptableDao->listQuery(&$datasource, $sql); 
    $level = $levelList[0]->getXptable_level();
    $logManager->message("init_zoneAffaire : metier SEC");
    $sql = "SELECT * FROM darkcity_metier WHERE xptable_level <= '".$level."' AND cmpname_name ='SEC' ORDER BY xptable_level DESC;";
    $metierList = $metierDao->listQuery(&$datasource, $sql); 
    $metier = $metierList[0];
    $logManager->message("init_zoneAffaire : ".$metier->getXptable_level()." => ".$metier->getMetier_libelle());
    if ($systemeDes->jeterOpposition($level, 0, 0, $metier->getXptable_level(), 0, 0) > 0) {
      $logManager->message("on ajoute le metier");
      $metiersDataBean->addMetier($metier);
    }
    // RPR
    $logManager->message("init_zoneAffaire : xptable RPR");
    $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$competence->getCompetence_RPR()."' ORDER BY xptable_level DESC;";
    $levelList = $xptableDao->listQuery(&$datasource, $sql); 
    $level = $levelList[0]->getXptable_level();
    $logManager->message("init_zoneAffaire : metier RPR");
    $sql = "SELECT * FROM darkcity_metier WHERE xptable_level <= '".$level."' AND cmpname_name ='RPR' ORDER BY xptable_level DESC;";
    $metierList = $metierDao->listQuery(&$datasource, $sql); 
    $metier = $metierList[0];
    $logManager->message("init_zoneAffaire : ".$metier->getXptable_level()." => ".$metier->getMetier_libelle());
    if ($systemeDes->jeterOpposition($level, 0, 0, $metier->getXptable_level(), 0, 0) > 0) {
      $logManager->message("on ajoute le metier");
      $metiersDataBean->addMetier($metier);
    }
    // PIL
    $logManager->message("init_zoneAffaire : xptable PIL");
    $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$competence->getCompetence_PIL()."' ORDER BY xptable_level DESC;";
    $levelList = $xptableDao->listQuery(&$datasource, $sql); 
    $level = $levelList[0]->getXptable_level();
    $logManager->message("init_zoneAffaire : metier PIL");
    $sql = "SELECT * FROM darkcity_metier WHERE xptable_level <= '".$level."' AND cmpname_name ='PIL' ORDER BY xptable_level DESC;";
    $metierList = $metierDao->listQuery(&$datasource, $sql); 
    $metier = $metierList[0];
    $logManager->message("init_zoneAffaire : ".$metier->getXptable_level()." => ".$metier->getMetier_libelle());
    if ($systemeDes->jeterOpposition($level, 0, 0, $metier->getXptable_level(), 0, 0) > 0) {
      $logManager->message("on ajoute le metier");
      $metiersDataBean->addMetier($metier);
    }
    // MED
    $logManager->message("init_zoneAffaire : xptable MED");
    $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$competence->getCompetence_MED()."' ORDER BY xptable_level DESC;";
    $levelList = $xptableDao->listQuery(&$datasource, $sql); 
    $level = $levelList[0]->getXptable_level();
    $logManager->message("init_zoneAffaire : metier MED");
    $sql = "SELECT * FROM darkcity_metier WHERE xptable_level <= '".$level."' AND cmpname_name ='MED' ORDER BY xptable_level DESC;";
    $metierList = $metierDao->listQuery(&$datasource, $sql); 
    $metier = $metierList[0];
    $logManager->message("init_zoneAffaire : ".$metier->getXptable_level()." => ".$metier->getMetier_libelle());
    if ($systemeDes->jeterOpposition($level, 0, 0, $metier->getXptable_level(), 0, 0) > 0) {
      $logManager->message("on ajoute le metier");
      $metiersDataBean->addMetier($metier);
    }
    // PER
    $logManager->message("init_zoneAffaire : xptable PER");
    $sql = "SELECT * FROM darkcity_xptable WHERE xptable_xp <= '".$competence->getCompetence_PER()."' ORDER BY xptable_level DESC;";
    $levelList = $xptableDao->listQuery(&$datasource, $sql); 
    $level = $levelList[0]->getXptable_level();
    $logManager->message("init_zoneAffaire : metier PER");
    $sql = "SELECT * FROM darkcity_metier WHERE xptable_level <= '".$level."' AND cmpname_name ='PER' ORDER BY xptable_level DESC;";
    $metierList = $metierDao->listQuery(&$datasource, $sql); 
    $metier = $metierList[0];
    $logManager->message("init_zoneAffaire : ".$metier->getXptable_level()." => ".$metier->getMetier_libelle());
    if ($systemeDes->jeterOpposition($level, 0, 0, $metier->getXptable_level(), 0, 0) > 0) {
      $logManager->message("on ajoute le metier");
      $metiersDataBean->addMetier($metier);
    }
    }
  
    // on regenerer la liste au bout de $DELAI_TRAVAIL
    $logManager->message("init_zoneAffaire : on regenerer la liste au bout de $DELAI_TRAVAIL");
    $metiersDataBean->setDateMetier($dateManager->getFutureDate($DELAI_TRAVAIL));
    $metiersDataBean->setDateMetier2($occupation->getOccupation_travail());
  
    // on sauvegarde les metieres en session
    $logManager->message("init_zoneAffaire : on sauvegarde les metieres en session");
    $sessionManager->save("metierList",$metiersDataBean);
  }
  else {
    $infoManager->setMessage("La liste des mtiers n&#39;a pas volue, elle sera regnre ".$dateManager->dateToString($metiersDataBean->getDateMetier()));
  }
  
  $logManager->message("init_zoneAffaire : fin");
?>